跳到主要內容

四軸銑削(二)

文章日期:2008-03-22 17:30







三軸連動銑削加工(X+Y+A)

在工件為圓柱的前題下要用圓柱表面上,使用直徑較小的銑刀(以直徑20mm為例),銑出較大圓溝(溝寬64mm),基本上只要兩軸連動及G41G42補正就可以,不過,如果要用較小直徑20mm銑刀銑出較大圓溝直徑64mm,並要求此圓溝的溝壁如同64mm銑刀銑出的效果就得以三軸連動(X+Y+A)的方式來加工才行

三軸連動加工要訣是先找出圓溝的每一處外形是以直徑64mm銑刀圓周邊的哪一個部位所銑出來的,然後透過移動XY軸的方法,將直徑20mm銑刀圓周邊移到該位置,如下圖所示,並將A軸如同二軸連動那樣旋轉,即可用直徑20mm銑刀銑出像直徑64mm銑刀所銑出的圓溝。

 
 



用AutoLisp模擬較小的銑刀來銑出像直徑64mm銑刀所銑出的圓溝,並輸出CNC程式:
(defun c:kk() ;;for variable diameter of r1
  (setq r1 10.0 xc 0.0 yc 0.0 d 0.0)
  (setq r1 (/ (getreal "Enter the dia of finishing milling : ") 2))
  (setq r0 32.0  x1 0.0 y1 0.0  x2 0.0 y2 0.0  z2 0.0  xp 0.0 yp 0.0 zp 0.0 )
  (setq xp 121.205 yp 0  zp 110.)
  (setq file01 (open "C://test.nc" "w"))
  (princ "%\n" file01)
  (princ "O0005\n" file01)
  (princ "G0X121.205 Y0. Z110. A0. F600\n" file01)
  (princ "S800 M03\n" file01)
  (princ "M08  F70\n" file01)
  (setq x2 121.205   y2 0.0  z2 75.0 ctype 1)
  (princ "G1 " file01)
  (pp1)
  (setq y2 (- r0 r1) )
  (princ "  " file01)
  (pp1)
  (setq x2 90.)
  (princ "  " file01)
  (pp1)
  (setq y2 (* -1 y2)  ctype 3 ppr (- r0 r1) )
  (princ "G3 " file01)
  (pp1)

  (setq x2 121.205  ctype 1)
  (princ "G1 " file01)
  (pp1)
  (setq radChg (/ 180.0 3.1415926) angChg (/ 3.1415926 180.0))
  (setq cosCta (cos angChg) sinCta (sin angChg))
  (setq iniCta 0.0  cta0 0.0  cta1 0.0  ctaTatal 0.0  iniAxial 0.0 wkAxial 0.0)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  (setq xp 121.2051 yp -32  x2 149.9004 y2 -46.2611)
  (setq ctype 2 ppr 36.0)
  (scir)  ;obtain xc, yc, iniCta, cta0, cta1,
  (setq pillarDia (* 3.1415926 210) )
  (setq i1 1   x1wk (- xp xc)  y1wk (- yp yc))
  (setq x2mem x2  y2mem y2  a2 0.0)
  (while (< i1 ctaTatal)
    (setq x2wk (+ (* x1wk cosCta) (* y1wk sinCta) ))
    (setq y2wk (- (* y1wk cosCta) (* x1wk sinCta) ))
    (setq ycc (+ yc (* (+ r0 ppr) (/ y2wk ppr))) )
    (setq x2 (+ xc (* (+ r1 ppr) (/ x2wk ppr))) )
    (setq y2 (+ yc (* (+ r1 ppr) (/ y2wk ppr))) )
    (if (= i1 1)
       (princ "G1 " file01)
       (princ "   " file01) )
    (setq y2 (- y2 ycc) a2 (* 360 (/  ycc pillarDia)) )
    (ppAxial)
    (setq i1 (+ i1 1) x1wk x2wk y1wk y2wk) )

;;;;;;;;;the last endpoint of Arc
  (setq ycc (+ yc (* (+ 32 ppr) (/ (- y2mem yc) ppr))) )
  (setq x2 (+ xc (* (+ r1 ppr) (/ (- x2mem xc) ppr))) )
  (setq y2 (- (+ yc (* (+ r1 ppr) (/ (- y2mem yc) ppr))) ycc) )
  (setq a2  (* 360 (/  ycc pillarDia)) )
  (ppAxial)

;;;;;;;;; ;for slant line
  (setq mem y2   x2 254.4931  y2 -184.3234)
  (setq d12 (sqrt (+ (* (- x2 x2mem)(- x2 x2mem)) (* (- y2 y2mem)(- y2 y2mem)) )))
  (setq x3 (- x2 (* r1 (/ (- y2 y2mem) d12) )))
  (setq y3 (+ y2 (* r0 (/ (- x2 x2mem) d12) )))
  (setq x2 x3  y2 mem)
  (setq a2 (* 360 (/ y3  pillarDia)))
  (ppAxial)

;;;;;;;;;; milling a hole
  (setq x2 254.4931  y2 -184.3234 ctype 3 ppr (- r0 r1))
  (setq x3 (- x2 (* (- (+ r0 r0) r1) (/ (- y2 y2mem) d12) )))
  (setq y2 (abs mem) x2 x3)
  (princ "G3 " file01)
  (pp1)
;;;;;;;;;;;;revering
;;;;;;;;;;;;obtain arc data
  (setq x2 121.205  y2 r0 )
  (setq xp 200.9143   yp -7.6142  ctype 3  ppr (+ 36. (* 2 r0)) )
  (scir)  ;obtain xc, yc, iniCta, cta0, cta1,
  (setq x2mem x2  y2mem y2  a2 0.0)
;;;;;;;;; ;for revering slant line
  (setq x2 (+ xc (* (- ppr r1) (/ (- xp xc) ppr))) )
  (setq y2 (abs mem) a2 (* 360 (/ ycc pillarDia)))
  (ppAxial)
;;;;;;;;;;milling revering arc
  (setq x2 121.205  y2 r0  xp 200.9143   yp -7.6142)
  (setq i1 1   x1wk (- xp xc)  y1wk (- yp yc))
  (while (< i1 ctaTatal )
    (setq x2wk (- (* x1wk cosCta) (* y1wk sinCta) ))
    (setq y2wk (+ (* y1wk cosCta) (* x1wk sinCta) ))
    (setq ycc (+ yc (* (- ppr r0) (/ y2wk ppr))) )
    (setq x2  (+ xc (* (- ppr r1) (/ x2wk ppr))) )
    (setq y2  (* (- r0 r1) (/ y2wk ppr)) )
    (if (= i1 1)
       (princ "G1 " file01)
       (princ "   " file01) )
    (setq a2 (* 360 (/  ycc pillarDia)) )
    (ppAxial)
    (setq i1 (+ i1 1) x1wk x2wk y1wk y2wk) )

;;;;;;;;;the last endpoint of Arc
  (setq ycc (+ yc (* (- ppr r0) (/ (- y2mem yc) ppr))) )
  (setq y2  (* (- r0 r1) (/ (- y2mem yc) ppr)) )
  (setq x2 x2mem  a2  (* 360 (/  ycc pillarDia)) )
  (ppAxial)
  (princ "G0 Z150.\n" file01)           ;raising tool
  (princ "M99\n" file01)
  (princ "%\n" file01)
  (close file01)
  (setvar "osmode" 1)
)
;;;;;;;;;;;;;;;;;;;;;;;以下是子程式;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun pp1()
  (setq pxs(rtos x2 2 3) pys(rtos y2 2 3) pzs(rtos z2 2 3))
  (setq pxl(strlen pxs) pyl(strlen pys) pzl(strlen pzs))
  (setq pxn(- 7 pxl) pyn(- 7 pyl) pzn(- 7 pzl))
  (if (> (abs (- xp x2))  0.001)
    (progn
      (princ " X" file01)   (princ pxs file01)
      (if ( or (< (abs (- (fix x2) x2)) 0.001) (< (- 1 (abs (- (fix x2) x2))) 0.001) ) (princ "." file01) )
      (repeat pxn (princ " " file01))  ))
  (if (> (abs (- yp y2))  0.001)
    (progn
      (princ " " file01)  (princ "Y" file01)  (princ pys file01)
      (if ( or (< (abs (- (fix y2) y2)) 0.001) (< (- 1 (abs (- (fix y2) y2))) 0.001) ) (princ "." file01) )
      (repeat pyn (princ " " file01)) ))
  (if (> (abs (- zp z2)) 0.001)
    (progn
      (princ " " file01)  (princ "Z" file01)  (princ pzs file01)
      (if ( or (< (abs (- (fix z2) z2)) 0.001) (< (- 1 (abs (- (fix z2) z2))) 0.001) ) (princ "." file01) )))
  (if (> ctype 1 )
       (progn
          (float ppr)
          (princ " " file01)  (princ "R" file01)  (princ ppr file01)  ))
  (princ "\n" file01)
  (setq xp x2 yp y2  zp z2)
)


(defun ppAxial()
  (setq pxs(rtos x2 2 3) pys(rtos y2 2 3) pzs(rtos a2 2 3))
  (setq pxl(strlen pxs) pyl(strlen pys) pzl(strlen pzs))
  (setq pxn(- 7 pxl) pyn(- 7 pyl) pzn(- 7 pzl))
  (princ " X" file01)   (princ pxs file01)
  (if ( or (< (abs (- (fix x2) x2)) 0.001) (< (- 1 (abs (- (fix x2) x2))) 0.001) )  (princ "." file01) )
  (repeat pxn (princ " " file01))
  (princ " Y" file01)   (princ pys file01)
  (if ( or (< (abs (- (fix y2) y2)) 0.001) (< (- 1 (abs (- (fix y2) y2))) 0.001) ) (princ "." file01) )
  (repeat pyn (princ " " file01))
  (princ " A" file01)  (princ pzs file01)
  (if ( or (< (abs (- (fix a2) a2)) 0.001) (< (- 1 (abs (- (fix a2) a2))) 0.001) ) (princ "." file01) )
  (princ "\n" file01)
)


(defun scir ()
  (setq d (/ (distance (list xp yp) (list x2 y2)) 2))
  (if (> d 0)
    (progn
      (setq k1 (sqrt (- (* ppr ppr) (* d d))) )
      (if (< ctype 2.5)
           (setq xc (+ (/ (+ xp x2) 2) (/ (* k1 (- y2 yp)) d 2))
                 yc (- (/ (+ yp y2) 2) (/ (* k1 (- x2 xp)) d 2)))
           (setq xc (- (/ (+ xp x2) 2) (/ (* k1 (- y2 yp)) d 2))
                 yc (+ (/ (+ yp y2) 2) (/ (* k1 (- x2 xp)) d 2)))  )))
  (setq ctaTatal (* radChg (atan (/ d k1)) 2))
  (setq x0 xp iniCta 0.0 cta0 0.0)
  (if (< (abs (- xc xp )) 0.01)
      (if (> yp yc)
           (setq iniCta 90.0)
           (setq iniCta 270.0) )
      (if (< (abs (- yc yp )) 0.01)
         (if (> xp xc)
           (setq iniCta 0.0)
           (setq iniCta 180.0) )
         (progn
           (setq cta0 (* radChg (atan (abs (/ (- yp yc) (- xp xc))))))
           (if (> xp xc )
              (if (> yp yc )
                 (setq iniCta cta0)
                 (setq iniCta (- 360.0 cta0)  cta0 iniCta) )
              (if (> yp yc )
                 (setq iniCta (- 180.0 cta0)  cta0 iniCta)
                 (setq iniCta (+ 180.0 cta0)  cta0 iniCta) )))))
)
請看續文
http://tw.myblog.yahoo.com/cu01joe/article?mid=807&prev=1615&next=795&l=f&fid=5

留言

這個網誌中的熱門文章

管牙PT

文章日期:2009-07-12 23:08 本文旨在講解 PT錐度管牙 常見的標準的管牙規範計有:  NPT , NPTF ,NPS , PS ,PF , PT.. ,前3者有N開頭的是美國標準的管牙 ,牙角(又稱螺紋角)60度 ,後面這3者則是英國標準的管牙 ,牙角55度 ,這些代號裡面的T意指Taper ,也就是錐度牙 。 不論是PT還是NPT,他們的錐度值都是1/16, 換算成角度值是 2*tan-1(0.5/16)=3.57982度 = 3度34分47.356秒, 3.57982度為什麼等於3度34分47.356分呢? 這是因為角度的單位換算是六十進位,3.5798212度後面的小數點0.5798212"度"要換算成""分"時,0.5798212度 = 0.57982*60分 = 34.789273分 ,而34.789273分後面的小數點0.789273分要換算成秒, 則0.789273*60秒 = 47.356秒。 此外,切記在車削錐牙時得採半錐角,也就是1度47分23.7秒。 NPT (美制管用推拔螺紋) 制定在 ANSI 規格中,稱為美國標準管用推拔螺紋,有外螺紋與內螺紋。 NPT 外螺紋不但對 NPT 內螺紋配合,有時也配合 NPSC ,這點類似 PT 。螺紋峰與根切成同形,又因公差大,餘隙、緊密兩種配合都可用。如用潤滑劑,則變成耐密用,耐密用者另有稱為乾封閉之如 NPTF,NPSF 等付有 F 之一群。 NPTF (美制管用耐密推拔螺紋) NPTF 外螺紋,像 PT.NPT 有時也配合 NPSF.NPSI (都是內螺紋)。因這種螺紋都是峯尖、根淺,峯不是密接於根就是食進,可防止在此部分變成螺旋狀間隙,這是前述耐密性之理由。 PT( 英制管用推拔螺紋 ) 以前是使用面直角的螺紋峯,現在將規格統一為軸直角者。 JIS 定為耐密用而組合外螺紋和內螺紋。 PT 外螺紋除了配合 PT 內螺紋,有時也配合 PS 。 PS ( 英制管用推拔螺紋用平行內螺紋   ─   耐密用 )     屬於 JIS 內 PT 的規格,舊 JIS 裏 PS 牙的外螺紋已被取消,配合的外螺紋現規定要用 PT 。 PF( 英制管用平行螺紋 ...

G76車牙

文章日期:2008-10-10 00:02 工具機若使用 Fanuc 控制器,車牙轉速有一個先天上的限制: S × P < 4000 請參考 車牙的 NC 碼計有 G32 、 G92 、 G76 三種 ( 使用方法 這三個指令中,手寫 G92 一般是直進式切削,牙刀的兩刃皆受力,直進式切削 ,每刀吃深不多,以免造成牙面粗糙,反觀 G76 則是斜進式單邊車削 ,可以有較大的進刀深度 , 寫法也簡短方便廣受採用,不論多大的牙, G76 只要兩個單節就可解決了。 由於 G76 有單邊切削的效果,廣受學校或職訓單位的喜愛,如下圖所示。         Fanuc0T系列控制器之G76 格式如下 : 指令說明 (m) : 精車次數。 (r) : 車牙末端 拔刀時留下的不完全牙長度(倍率)。 (a) :牙刀之角度,可選擇 80 °、 60 °、 55 °、 30 °、 29 °、 0 °等角度。 Q( △ dmin) :最小進刀深度。 R(d) :精車預留量。 X(u) :螺紋程式終點的 X 軸方向座標。 Z(w) :螺紋程式終點的 Z 軸方向座標。 R(i) :螺紋部份的半徑差,如果 I=0 可作一般直線螺紋車削。 P(k) :螺紋高度即牙深度, K 為正值在 X 軸方向用半徑值指定。 Q( △ d) :第一次螺紋的切削深度,用半徑值指定。 F(l) :螺紋的導程,與 G32 相同。 以M20X2.5外螺紋為例 , 常見的寫法如下 : G76 P01 00 60 Q40 R0.02 G76 X16.933 Z-10.0  P1533    Q500   F2.5 1. G76第一行的 P01 00 60 ,這01表示最後精車時只車一刀精車, 00 表示車牙最後拔刀時不留倒角 ,此所謂之倒角是 不完全牙之意 ,亦即因拔刀而在工件上留下牙深較淺的牙 ,Fanuc的拔刀精度是0.1倍的導程 , 若是此值改成10,則表示拔刀時在軸向會留下一倍導程長度的不完全牙,這一倍就是指導程2.5的一倍,也就是不完全牙會有2.5mm那麼長, 60 ...

錐度值

文章日期:2008-02-01 08:40 做傳統車床的人通常會遇到車錐度時要調複式刀座,而複式刀座所調的角度為工件錐度部位之半錐角,為甚麼要調的是半錐角,而不是全錐角呢?為甚麼工件的錐度值乘以 28.65 就是所要調的是半錐角呢? 如下圖所示,將工件錐度部位的稜線延伸至交接,就可看出工件完整的錐度,將這工件全錐度的一半定為 a ,則可得半錐角,由於複式刀座的前進方向是水平的,所以只要將複式刀座依逆時針方向調動半錐角,就可車削工件的錐度。 工件錐度部位之錐度值的計算公式: T=(D-d)/L D 為錐度部位之大徑, d 為錐度部位之小徑, L 為錐度部位之軸向長度。 工件錐度部位之半錐角計算公式: tan(a) = 0.5*(D-d)/L tan 是指正切函數,意思就是 : "對邊除以鄰邊",三角函數裡所指的三角形一定要用直角三角形,直角三角形最長的邊稱為斜邊,鄰邊與斜邊所包的角度就是三角函數角,如下圖的角 a ,三角函數角 a 對面的那個邊就是對邊,三角形會因擺放的位置不同而顯得有點昏頭轉向,不過只要依照上述的原則,就不會認錯邊名了。 從上述說明來看下圖就可以瞭解半錐角計算公式 tan(a) = 0.5*(D-d)/L ,從下圖放大的三角形中可以看出鄰邊長度是 L ,對邊長度是 0.5*(D-d) ,所以 tan(a) =  對邊 / 鄰邊 =0.5*(D-d)/L ,如果已算出 0.5*(D-d)/L 的值要反推角 a 的角度,就必需要這樣做 a=tan -1 (0.5*(D-d)/L) ,也就是用反三角來得角 a 大的小,反三角的值在三十年前常用查表方式求得,近年來只要按一按計算機就可顯示出,不過這對於在工作現場的人來說太麻煩了,所以就有一個半錐角速算公式  : a=28.65*( 錐度值 )=28.65*(D-d)/L) ,那麼這 28.65 到底是怎麼來的呢 ? 其實只要用計算機按按看就可以得到答案,將計算機輸入 1/tan(1 0 ) ,就可得到 57.2899616307594246... ,但由於我們要求的是半錐角,所以再將此值除以 2 就可得到 28.6449808153797... ,簡以 28.65 代之即可,不過這個半錐角速算公式是近似值,只能用來大概調動複式刀座,真正的校正還得...